## MEGAsync-5.2.1.0_Linux.tar.gz

=== contrib/cmake/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0091 NEW)

set(MEGA_PROJECT_NAME "MEGAsync-desktop-" CACHE STRING "Project name, SDK will declare and append 32/64")
set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose output")

#add a target to have all files within qtcreator projects view
FILE(GLOB_RECURSE ui_files "${RepoDir}/src/MEGASync/gui/*.h" "${RepoDir}/src/MEGASync/gui/*/*.ui" "${RepoDir}/src/MEGASync/gui/*.qrc")
add_custom_target(ui_assets SOURCES ${ui_files})

if(CMAKE_HOST_APPLE)

    # Minimum deployment target differs if we are building for intel or arm64 targets
    # CMAKE_SYSTEM_PROCESSOR and CMAKE_HOST_SYSTEM_PROCESSOR are only available after project()
    execute_process(
        COMMAND uname -m
        OUTPUT_VARIABLE HOST_ARCHITECTURE
        OUTPUT_STRIP_TRAILING_WHITESPACE)

    # Setup CMAKE_OSX_DEPLOYMENT_TARGET before project()
    if(CMAKE_OSX_ARCHITECTURES STREQUAL "arm64" OR (NOT CMAKE_OSX_ARCHITECTURES AND HOST_ARCHITECTURE STREQUAL "arm64"))
        set(CMAKE_OSX_DEPLOYMENT_TARGET "11.1" CACHE STRING "Minimum OS X deployment version")
    else()
        set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")
    endif()

    message(STATUS "Minimum OS X deployment version is set to ${CMAKE_OSX_DEPLOYMENT_TARGET}")

    unset(HOST_ARCHITECTURE)

endif()

PROJECT(${MEGA_PROJECT_NAME})

#Qt settings
if (CMAKE_HOST_WIN32)
    set (UiDir "win")
    set (QTCOMPONENS_REQUIRED_PLATFORM WinExtras)
    set (TARGET_LINK_LIBRARIES_PLATFORM Qt5::WinExtras)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DWIN32)
elseif (CMAKE_HOST_APPLE)
    set (UiDir "macx")
    set (QTCOMPONENS_REQUIRED_PLATFORM MacExtras Svg)
    set (TARGET_LINK_LIBRARIES_PLATFORM Qt5::MacExtras Qt5::Svg)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -D__APPLE__ -D__GNUC__=4 -D__APPLE_CC__)
else()
    set (UiDir "linux")
    set (QTCOMPONENS_REQUIRED_PLATFORM Svg X11Extras)
    set (TARGET_LINK_LIBRARIES_PLATFORM Qt5::Svg Qt5::X11Extras xcb)
endif()

set (MEGA_QT_REQUIRED_COMPONENTS Core Network Gui Widgets LinguistTools Quick Qml ${QTCOMPONENS_REQUIRED_PLATFORM})
set (MEGA_QT_LINK_LIBRARIES Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Network Qt5::Quick Qt5::Qml ${TARGET_LINK_LIBRARIES_PLATFORM})

list(APPEND QML_DIRS "${MEGAsyncDir}/gui/qml")
set(QML_IMPORT_PATH "${QML_DIRS}" CACHE STRING "Qt Creator extra qml import paths")

set (UNCHECKED_ITERATORS 0 CACHE STRING "")

set (USE_LIBUV 1 CACHE STRING "")
set (USE_MEGAAPI 1 CACHE STRING "")
set (USE_MEDIAINFO 1 CACHE STRING "")
set (USE_LIBRAW 1 CACHE STRING "")
set (USE_SODIUM 1 CACHE STRING "")
set (USE_FFMPEG 1 CACHE STRING "")
set (USE_PDFIUM 1 CACHE STRING "")
set (USE_FREEIMAGE 1 CACHE STRING "")
set (USE_QT 1 CACHE STRING "")
set (ENABLE_LOG_PERFORMANCE 1 CACHE STRING "")
set (NO_READLINE 0 CACHE STRING "")
set (USE_DRIVE_NOTIFICATIONS 1 CACHE STRING "")
set (USE_PCRE 0 CACHE STRING "")
if (WIN32)
    set (MEGA_LINK_DYNAMIC_CRT 1)  # since we are linking with QT official DLLs
else()
    set(USE_PTHREAD 1 CACHE STRING "")
endif()

set(RepoDir "${CMAKE_CURRENT_LIST_DIR}/../.."  CACHE STRING "")
set(MEGAsyncDir "${RepoDir}/src/MEGASync")
set(MEGAupdaterDir "${RepoDir}/src/MEGAUpdater")
set(MEGAShellExtDir "${RepoDir}/src/MEGAShellExt")

get_filename_component(MEGAsyncDir ${MEGAsyncDir} REALPATH)

## Use prebuild 3rdparties
set (USE_PREBUILT_3RDPARTY 1 CACHE STRING "")

## Use vcpkg 3rdparties
If (WIN32 OR APPLE)
    set (USE_THIRDPARTY_FROM_VCPKG 1 CACHE STRING "")
    set (prebuilt_dir "${MEGAsyncDir}/../../../3rdparty_desktop")
else()
    set (USE_THIRDPARTY_FROM_VCPKG 0 CACHE STRING "")
endif()

set(Mega3rdPartyDir "${prebuilt_dir}"  CACHE STRING "")

#set(Mega3rdPartyDir "C:/path/to/vcpkg/parent/folder"  CACHE STRING "")


# this line points to the MEGA SDK repo that you want to build MEGAsync against
include(${MEGAsyncDir}/mega/contrib/cmake/CMakeLists.txt)

set(3RDPARTY_RUNTIME_PATH "PATH=%PATH%" "${Mega3rdPartyDir}/vcpkg/installed/${VCPKG_TRIPLET}/debug/bin;${QT_DIR}/bin")

set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOUIC_SEARCH_PATHS "${MEGAsyncDir}/gui/${UiDir}"
                               "${MEGAsyncDir}/gui/node_selector/gui/${UiDir}"
                               "${MEGAsyncDir}/transfers/gui/${UiDir}"
                               "${MEGAsyncDir}/transfers/gui/DuplicatedNodeDialogs/${UiDir}"
                               "${MEGAsyncDir}/syncs/gui/Backups/${UiDir}"
                               "${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}"
                               "${MEGAsyncDir}/stalled_issues/gui/${UiDir}"
                               "${MEGAsyncDir}/stalled_issues/gui/stalled_issues_cases/${UiDir}")

#AUTOMOC
set(CMAKE_AUTOMOC ON)
if (QT_VERSION VERSION_GREATER 5.7.99)
    message(STATUS "Enabling automoc predefines and including config.h")
    set(AUTOMOC_COMPILER_PREDEFINES ON)
    set (CMAKE_AUTOMOC_MOC_OPTIONS ${CMAKE_AUTOMOC_MOC_OPTIONS} --include "${MEGAsyncDir}/mega/include/config.h" )
else()
    message(STATUS "Disabling automoc predefines and including config.h. Qt version = ${QT_VERSION}")
endif()

include_directories( "${MEGAsyncDir}/mega/bindings/qt" )
include_directories( "${MEGAsyncDir}/control" )
include_directories( "${MEGAsyncDir}/model" )
include_directories( "${MEGAsyncDir}/gui" )
include_directories( "${MEGAsyncDir}/stalled_issues/model" )
include_directories( "${MEGAsyncDir}/stalled_issues/gui" )
include_directories( "${MEGAsyncDir}/stalled_issues/gui/${UiDir}" )
include_directories( "${MEGAsyncDir}/gui/node_selector/gui/${UiDir}")
include_directories( "${MEGAsyncDir}/gui/node_selector" )
include_directories( "${MEGAsyncDir}/platform" )
include_directories( "${MEGAsyncDir}/gui/${UiDir}" )
include_directories( "${MEGAsyncDir}/notifications/${UiDir}" )
include_directories( "${MEGAsyncDir}/notifications" )
include_directories( "${MEGAsyncDir}/transfers/model" )
include_directories( "${MEGAsyncDir}/transfers/gui" )
include_directories( "${MEGAsyncDir}/transfers/gui/${UiDir}" )
include_directories( "${MEGAsyncDir}/transfers/gui/DuplicatedNodeDialogs" )
include_directories( "${MEGAsyncDir}/transfers/gui/DuplicatedNodeDialogs/${UiDir}" )
include_directories( "${MEGAsyncDir}/syncs/Backups" )
include_directories( "${MEGAsyncDir}/syncs/gui/Backups/${UiDir}" )
include_directories( "${MEGAsyncDir}/syncs/gui/Twoways" )
include_directories( "${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}" )
include_directories( "${MEGAsyncDir}/UserAttributesRequests" )


set (TS_FILES
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_ar.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_de.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_en.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_es.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_fr.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_id.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_it.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_ja.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_ko.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_nl.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_pl.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_pt.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_ro.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_ru.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_th.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_vi.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_zh_CN.ts
    ${MEGAsyncDir}/gui/translations/MEGASyncStrings_zh_TW.ts )

set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION "${MEGAsyncDir}/gui/translations/")
qt5_add_translation(QM_FILES ${TS_FILES})

set (FORMS
    ${MEGAsyncDir}/gui/${UiDir}/AlertItem.ui
    ${MEGAsyncDir}/gui/${UiDir}/AlertFilterType.ui
    ${MEGAsyncDir}/gui/${UiDir}/BugReportDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/FilterAlertWidget.ui
    ${MEGAsyncDir}/gui/${UiDir}/InfoDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/UploadToMegaDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/PasteMegaLinksDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ImportMegaLinksDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ImportListWidgetItem.ui
    ${MEGAsyncDir}/gui/${UiDir}/CrashReportDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/SettingsDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/NotificationsSettings.ui
    ${MEGAsyncDir}/gui/${UiDir}/AccountDetailsDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/DownloadFromMegaDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ChangeLogDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/StreamingFromMegaDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/MegaProgressCustomDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/PlanWidget.ui
    ${MEGAsyncDir}/gui/${UiDir}/UpgradeDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/AddExclusionDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/StatusInfo.ui
    ${MEGAsyncDir}/gui/${UiDir}/PSAwidget.ui
    ${MEGAsyncDir}/gui/${UiDir}/UpgradeOverStorage.ui
    ${MEGAsyncDir}/gui/${UiDir}/ChangePassword.ui
    ${MEGAsyncDir}/gui/${UiDir}/Login2FA.ui
# added per platform    ${MEGAsyncDir}/gui/${UiDir}/LockedPopOver.ui
    ${MEGAsyncDir}/gui/${UiDir}/VerifyLockMessage.ui
    ${MEGAsyncDir}/gui/${UiDir}/MegaInfoMessage.ui
    ${MEGAsyncDir}/gui/${UiDir}/OverQuotaDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ProxySettings.ui
    ${MEGAsyncDir}/gui/${UiDir}/BandwidthSettings.ui
    ${MEGAsyncDir}/gui/${UiDir}/NodeNameSetterDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ScanningWidget.ui
    ${MEGAsyncDir}/gui/${UiDir}/CancelConfirmWidget.ui
    ${MEGAsyncDir}/gui/${UiDir}/LowDiskSpaceDialog.ui
    ${MEGAsyncDir}/gui/${UiDir}/ViewLoadingScene.ui
    ${MEGAsyncDir}/gui/node_selector/gui/${UiDir}/NodeSelector.ui
    ${MEGAsyncDir}/gui/node_selector/gui/${UiDir}/NodeSelectorLoadingDelegate.ui
    ${MEGAsyncDir}/gui/node_selector/gui/${UiDir}/NodeSelectorTreeViewWidget.ui
    ${MEGAsyncDir}/gui/node_selector/gui/${UiDir}/SearchLineEdit.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/FolderBinder.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/IgnoresEditingDialog.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/SyncAccountFullMessage.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/SyncStallModeSelector.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/SyncSettingsUIBase.ui
    ${MEGAsyncDir}/syncs/gui/Twoways/${UiDir}/BindFolderDialog.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/BackupsWizard.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/AddBackupDialog.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/RemoveBackupDialog.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/BackupRenameWidget.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/BackupNameConflictDialog.ui
    ${MEGAsyncDir}/syncs/gui/Backups/${UiDir}/OpenBackupsFolder.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/InfoDialogTransfersWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/InfoDialogTransferDelegateWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/InfoDialogTransferLoadingItem.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransferWidgetHeaderItem.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransferManager.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransferManagerDragBackDrop.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransfersWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransfersStatusWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransfersSummaryWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransferManagerDelegateWidget.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/TransferManagerLoadingItem.ui
    ${MEGAsyncDir}/transfers/gui/DuplicatedNodeDialogs/${UiDir}/DuplicatedNodeDialog.ui
    ${MEGAsyncDir}/transfers/gui/DuplicatedNodeDialogs/${UiDir}/DuplicatedNodeItem.ui
    ${MEGAsyncDir}/transfers/gui/${UiDir}/SomeIssuesOccurredMessage.ui
    ${MEGAsyncDir}/stalled_issues/gui/${UiDir}/StalledIssueChooseWidget.ui
    ${MEGAsyncDir}/stalled_issues/gui/${UiDir}/StalledIssueFilePath.ui
    ${MEGAsyncDir}/stalled_issues/gui/${UiDir}/StalledIssueHeader.ui

=== src/MEGAShellExtDolphin/CMakeLists.txt ===
project(megasyncplugin)

cmake_minimum_required(VERSION 2.8.12)
include(FeatureSummary)
set(QT_MIN_VERSION "5.0.0")
set(KF5_MIN_VERSION "5.0.0")

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Core Network)

find_package(ECM 1.2.0 REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS CoreAddons KIO)

set_package_properties(DolphinVcs PROPERTIES
    DESCRIPTION "the Dolphin plugin library"
    URL "http://dolphin.kde.org/"
    TYPE REQUIRED
    PURPOSE "Provides plugin interfaces for Dolphin."
)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
include(ECMMarkNonGuiExecutable)
include(GenerateExportHeader)

set(CMAKE_AUTOMOC ON)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
add_definitions(-DWITH_KF5)


#---OVERLAY PLUGIN---
if (KF5_VERSION)
	if (NOT KF5_VERSION VERSION_LESS 5.16.0)
		set(MEGASYNCDOLPHINOVERLAYPLUGIN megasyncdolphinoverlayplugin)
		if (NOT DEFINED PLUGIN_INSTALL_DIR)
				set(PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/plugins) #so that kcoreaddons install in the right path (see https://github.com/KDE/kcoreaddons/blob/master/KF5CoreAddonsMacros.cmake)
		endif()
		kcoreaddons_add_plugin(${MEGASYNCDOLPHINOVERLAYPLUGIN} INSTALL_NAMESPACE "kf5/overlayicon"
							   JSON megasync-plugin-overlay.json SOURCES megasync-plugin-overlay.cpp)
		target_link_libraries(${MEGASYNCDOLPHINOVERLAYPLUGIN} KF5::CoreAddons KF5::KIOCore KF5::KIOWidgets)

		#---- ICONS ---- 
		set(HICOLOR_INSTALL_DIR ${KDE_INSTALL_FULL_ICONDIR}/hicolor)
		file(GLOB_RECURSE FILES32 "data/emblems/32x32/*")
		file(GLOB_RECURSE FILES64 "data/emblems/64x64/*")
		install( FILES ${FILES32} DESTINATION ${HICOLOR_INSTALL_DIR}/32x32/emblems)
		install( FILES ${FILES64} DESTINATION ${HICOLOR_INSTALL_DIR}/64x64/emblems)		
	endif()
endif()

#---ACTION PLUGIN---
set(MEGASYNCPLUGIN megasyncplugin)
add_library(${MEGASYNCPLUGIN} MODULE megasync-plugin.cpp)
target_link_libraries(${MEGASYNCPLUGIN} KF5::CoreAddons KF5::KIOCore KF5::KIOWidgets)

install(FILES megasync-plugin.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
install(TARGETS ${MEGASYNCPLUGIN} DESTINATION ${CMAKE_INSTALL_LIBDIR}/qt5/plugins)

=== src/MEGAUpdateGenerator/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.10)

set(MEGA_PROJECT_NAME "MEGAupdateGenerator-" CACHE STRING "Project name, SDK will declare and append 32/64")
set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose output")

PROJECT(${MEGA_PROJECT_NAME})

set (UNCHECKED_ITERATORS 0 CACHE STRING "")

# This needs static CRT linkage:
set (MEGA_LINK_DYNAMIC_CRT 0 CACHE STRING "")

set(RepoDir "${CMAKE_CURRENT_LIST_DIR}/../.."  CACHE STRING "")
set(SDKDir "${RepoDir}/src/MEGASync/mega")
set(MEGAupdateGeneratorDir "${RepoDir}/src/MEGAUpdateGenerator")

### Use prebuild 3rdparties
#set (USE_PREBUILT_3RDPARTY 1 CACHE STRING "")
#set(prebuilt_dir "${SDKDir}/bindings/qt/3rdparty")
##specify where 3rd party libraries are available
#set(Mega3rdPartyDir "${prebuilt_dir}"  CACHE STRING "")

# Use vcpkg 3rdparties
set (USE_THIRDPARTY_FROM_VCPKG 1 CACHE STRING "")
set(Mega3rdPartyDir "C:/path/to/vcpkg/parent/folder"  CACHE STRING "")

set (USE_FREEIMAGE 0 CACHE STRING "") # thumbnail generation etc done with QT, so no need for freeimage

# this line points to the MEGA SDK repo that you want to build MEGAsync against
include(${SDKDir}/contrib/cmake/CMakeLists.txt)

# avoid building other targets:
get_property(ALL_BUILDSYSTEM_TARGETS DIRECTORY PROPERTY BUILDSYSTEM_TARGETS)
foreach (TARG IN LISTS ALL_BUILDSYSTEM_TARGETS)
    message(STATUS "Excluding from build:  ${TARG}")
    set_target_properties(${TARG} PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)
endforeach(TARG)

add_definitions( -DSHOW_LOGS -D_CRT_SECURE_NO_WARNINGS -DPSAPI_VERSION=1 )
add_definitions( -DUSE_CRYPTOPP )

if(WIN32)
    add_definitions( -DUNICODE -D_UNICODE )  # needed for visual studio projects to use the unicode runtime libraries
endif()

if (CMAKE_HOST_WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4127")  # 4127: conditional expression is constant  (occurs in QT headers)
endif()

set (UPDATEGENERATOR_FILES
    ${MEGAupdateGeneratorDir}/MEGAUpdateGenerator.cpp
    ${SDKDir}/src/crypto/cryptopp.cpp
    ${SDKDir}/src/base64.cpp
    ${SDKDir}/src/logging.cpp
)

ImportStdVcpkgLibrary(cryptopp-staticcrt cryptopp-staticcrt cryptopp-staticcrt libcryptopp libcryptopp)

if(CMAKE_HOST_APPLE)
    add_executable(MEGAUpdateGenerator MACOSX_BUNDLE ${MAC_RESOURCES} ${UPDATEGENERATOR_FILES} )
    target_link_libraries(MEGAUpdateGenerator cryptopp-staticcrt)
    target_include_directories(MEGAUpdateGenerator PRIVATE ${SDKDir}/include/mega/posix)
else(CMAKE_HOST_APPLE)
    add_executable(MEGAUpdateGenerator ${UPDATEGENERATOR_FILES} )
    if(CMAKE_HOST_WIN32)
        target_link_libraries(MEGAUpdateGenerator cryptopp-staticcrt ws2_32 Urlmon.lib Shlwapi.lib)
        target_include_directories(MEGAUpdateGenerator PRIVATE ${SDKDir}/include/mega/win32)
        set_property(TARGET MEGAUpdateGenerator PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    else(CMAKE_HOST_WIN32)
        target_link_libraries(MEGAUpdateGenerator cryptopp-staticcrt)
        target_include_directories(MEGAUpdateGenerator PRIVATE ${SDKDir}/include/mega/posix)
    endif(CMAKE_HOST_WIN32)
endif(CMAKE_HOST_APPLE)

target_include_directories(MEGAUpdateGenerator PRIVATE ${SDKDir}/include)

=== build/templates/MEGAShellExtDolphin/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAShellExtDolphin/PKGBUILD
 # @brief script to generate package dolphinmegasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

pkgname=dolphin-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA Desktop App plugin for Dolphin"
arch=('x86_64')
url="http://mega.nz/#sync"
license=() #TODO
depends=('megasync>=3.5' 'dolphin')
makedepends=('extra-cmake-modules' 'kde-sdk-meta' 'dolphin')
provides=("dolphin-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz")
noextract=()
md5sums=('MD5SUM')
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	cd "$pkgname-$pkgver"
	cmake $PWD
	make
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	make install DESTDIR=$pkgdir

	#fix missplaced .so for kf5
	if [ -d $pkgdir/usr/lib/qt5 ]; then
		cp -av $pkgdir/usr/lib/qt5/* $pkgdir/usr/lib/qt/
		rm -rf $pkgdir/usr/lib/qt5
	fi
}

=== build/templates/MEGAShellExtNautilus/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=nautilus-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA Desktop App plugin for Nautilus"
arch=('i686' 'x86_64')
url=""
license=() #TODO
groups=()
depends=('ca-certificates' 'megasync>=3.5' 'nautilus')
makedepends=( 'ca-certificates' 'qt5-base' 'nautilus' 'libnautilus-extension')
checkdepends=()
optdepends=()
provides=("nautilus-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=(debug strip)
install=megasync.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	#export DESKTOP_DESTDIR=$pkgdir/usr
	cd "$pkgname-$pkgver"
	sed -i "s#update_cache.path = \$\$PWD#update_cache.path = \$\${HICOLOR}#g" MEGAShellExtNautilus.pro
	if [ 0$(pacman -Q nautilus | awk '{print $NF}' | awk -F='-' '{print $1}' | awk -F "." '{FS=".";print $1*10000+$2*100+$3}') -gt 31503 ]; then 
	 echo "NEWER NAUTILUS REQUIRES SMALLER OVERLAY ICONS"
	 for i in data/emblems/64x64/*smaller.png; do mv $i ${i/-smaller/}; done
	else
	 echo "OLDER NAUTILUS DOES NOT REQUIRE SMALLER OVERLAY ICONS"
	 rm data/emblems/64x64/*smaller.png
	fi    
	qmake-qt5 || qmake
	make
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	make install INSTALL_ROOT=$pkgdir
}

=== build/templates/MEGAShellExtNemo/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=nemo-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA Desktop App plugin for Nemo"
arch=('i686' 'x86_64')
url=""
license=() #TODO
groups=()
depends=('ca-certificates' 'megasync>=3.5' 'nemo')
makedepends=('ca-certificates' 'qt5-tools' 'nemo')
checkdepends=()
optdepends=()
provides=("nemo-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
install=megasync.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	cd "$pkgname-$pkgver"
	sed -i "s#update_cache.path = \$\$PWD#update_cache.path = \$\${HICOLOR}#g" MEGAShellExtNemo.pro
	if [ 0$(pacman -Q nemo | awk '{print $NF}' | awk -F='-' '{print $1}' | awk -F "." '{FS=".";print $1*10000+$2*100+$3}') -gt 31503 ]; then 
	 echo "NEWER NEMO REQUIRES SMALLER OVERLAY ICONS"
	 for i in data/emblems/64x64/*smaller.png; do mv $i ${i/-smaller/}; done
	else
	 echo "OLDER NEMO DOES NOT REQUIRE SMALLER OVERLAY ICONS"
	 rm data/emblems/64x64/*smaller.png
	fi    
	qmake
	make
}

check() {
	cd "$pkgname-$pkgver"
#	make -k check  DESTDIR=$_bindir THE_RPM_BUILD_ROOT=$pkgdir
}

package() {
	cd "$pkgname-$pkgver"
#	make install
	#sed -i "s#gtk-update-icon-cache -f -t /#gtk-update-icon-cache -f -t \$(INSTALL_ROOT)/#g" Makefile
	make install INSTALL_ROOT=$pkgdir
}

=== build/templates/MEGAShellExtThunar/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package thunar-megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

pkgname=thunar-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA Desktop App plugin for Thunar"
arch=('i686' 'x86_64')
url="http://mega.nz/#sync"
license=() #TODO
depends=('thunar' 'megasync>=3.5')
makedepends=('ca-certificates' 'qt5-tools' 'thunar')
provides=("thunar-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
install=thunarext.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz")
noextract=()
md5sums=('MD5SUM')
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	cd "$pkgname-$pkgver"
	qmake || qmake-qt4 #qmake would fail when qt4 installed (due to some path missconfigurations)	
	make
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	for i in libMEGAShellExtThunar.so*; do install -D $i $pkgdir`pkg-config --variable=extensionsdir thunarx-3`/$i; done
}

=== build/templates/MEGAsync.debug/PKGBUILD ===
pkgname=megasync-debug
pkgver=MEGASYNC_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
arch=('any')
url="https://mega.nz/#sync"
license=('Freeware')
pkgdesc="Get more control over your data"
depends=(
'qt4'
'openssl'
'sqlite'
'c-ares'
'crypto++'
'ca-certificates'
)

=== build/templates/MEGAsync/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=megasync
pkgver=MEGASYNC_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="Get more control over your data"
arch=('i686' 'x86_64')
url="http://mega.nz/#sync"
license=() #TODO
groups=()
depends=('glibc>=2.33' 'gcc-libs>=10.2.0' 'qt5-base>=5.15' 'qt5-tools>=5.15' 'icu>=69.1' 'sqlite' 'openssl>=3.0.0' 'zlib' 'qt5-svg>=5.15' 'qt5-x11extras' 'bzip2' 'xz' 'libraw' 'double-conversion>=3.1.5' 'systemd' 'qt5-graphicaleffects' 'qt5-quickcontrols2' 'qt5-quickcontrols')
makedepends=('unzip' 'wget' 'ca-certificates' 'qt5-tools' 'ffmpeg-mega' 'pdfium-mega' 'bzip2' 'xz' 'qt5-declarative')
checkdepends=()
optdepends=('sni-qt: fix systray issue on KDE and LXQt', 'nautilus-megasync: for integration with nautilus')
provides=("megasync=${pkgver}" 'ffmpeg-mega')
conflicts=('megatools')
replaces=()
backup=()
options=(debug strip)
install=megasync.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
	sed -i -E "s/VER_PRODUCTVERSION_STR([[:space:]]+)\"(([0-9][0-9]*\.){3})(.*)\"/VER_PRODUCTVERSION_STR\1\"\2${pkgrel}\"/g" MEGASync/control/Version.h
	sed -i -E "s/VER_BUILD_ID([[:space:]]+)([0-9]*)/VER_BUILD_ID\1${pkgrel}/g" MEGASync/control/Version.h
}

build() {
	_bindir=$pkgdir/usr/bin
	cd "$pkgname-$pkgver"
	./configure -e -q -g -L
	# Link dynamically with freeimage if pdfium is required.
	ln -sfr $PWD/MEGASync/mega/bindings/qt/3rdparty/libs/libfreeimage*.so $PWD/MEGASync/mega/bindings/qt/3rdparty/libs/libfreeimage.so.3; \
	ln -sfn libfreeimage.so.3 $PWD/MEGASync/mega/bindings/qt/3rdparty/libs/libfreeimage.so; \
	qmake-qt5 "CONFIG += FULLREQUIREMENTS" QMAKE_RPATHDIR="/opt/mega/lib" MEGA.pro || qmake-qt4 "CONFIG += FULLREQUIREMENTS" QMAKE_RPATHDIR="/opt/mega/lib" MEGA.pro #qmake would fail when qt4 installed (due to some path missconfigurations)
	lrelease-qt5 MEGASync/MEGASync.pro || lrelease-qt4 MEGASync/MEGASync.pro 
	make ${BUILD_PARALLEL_JOBS}
}

check() {
	cd "$pkgname-$pkgver"
#	make -k check  DESTDIR=$_bindir THE_RPM_BUILD_ROOT=$pkgdir
}

package() {
	_bindir=$pkgdir/usr/bin
	mkdir -p $_bindir

	cd "$pkgname-$pkgver"
	make install TARGET=$_bindir/megasync INSTALL_ROOT=$pkgdir
	install -m 755 -p MEGASync/megasync $_bindir/megasync
	mkdir -p $pkgdir/etc/sysctl.d/
	echo "fs.inotify.max_user_watches = 524288" > $pkgdir/etc/sysctl.d/99-megasync-inotify-limit.conf
	mkdir -p $pkgdir/etc/udev/rules.d/
	echo "SUBSYSTEM==\"block\", ATTRS{idDevtype}==\"partition\"" > $pkgdir/etc/udev/rules.d/99-megasync-udev.rules
	mkdir -p $pkgdir/opt/mega/lib
	install -D MEGASync/mega/bindings/qt/3rdparty/libs/libfreeimage.so.* $pkgdir/opt/mega/lib
}
